From cd89c88566381146ae470359b7320e5034030bae Mon Sep 17 00:00:00 2001
From: Kandarp Joshi <kandarp.joshi@volansys.com>
Date: Wed, 9 Jun 2021 22:52:18 +0545
Subject: [PATCH] Modified driver code for the new acc chip

---
 drivers/iio/accel/st_lis2hh12.h         |  42 +-
 drivers/iio/accel/st_lis2hh12_core.c    | 905 ++++++++++++++++--------
 drivers/iio/accel/st_lis2hh12_trigger.c |  28 +-
 3 files changed, 672 insertions(+), 303 deletions(-)

diff --git a/drivers/iio/accel/st_lis2hh12.h b/drivers/iio/accel/st_lis2hh12.h
index 3c936e698ac1..c250ef76f531 100644
--- a/drivers/iio/accel/st_lis2hh12.h
+++ b/drivers/iio/accel/st_lis2hh12.h
@@ -15,10 +15,10 @@
 #include <linux/iio/iio.h>
 #include <linux/iio/trigger.h>
 
+
 #define LIS2HH12_WHO_AM_I_ADDR			0x0f
 #define LIS2HH12_WHO_AM_I_DEF			0x41
-
-#define LIS2DW12_WHO_AM_I_DEF			0x44
+#define LIS2DW12_WHO_AM_I_DEF           0x44
 
 #define LIS2HH12_CTRL1_ADDR			0x20
 #define LIS2HH12_CTRL2_ADDR			0x21
@@ -29,22 +29,31 @@
 #define LIS2HH12_CTRL7_ADDR			0x26
 
 #define LIS2HH12_ACT_THS_ADDR			0x1E
+#define LIS2DW12_WAKE_UP_THS_ADDR       0x34 
 #define LIS2HH12_ACT_DUR_ADDR			0x1F
+#define LIS2DW12_WAKE_UP_DUR_ADDR       0x35
 
 #define LIS2HH12_STATUS_ADDR		0x27
 #define LIS2HH12_DATA_XYZ_RDY		0x08
+#define LIS2DW12_DATA_XYZ_RDY       0x01
 
 #define LIS2HH12_FIFO_CTRL_ADDR			0x2E
 
+
 #define LIS2HH12_OUTX_L_ADDR		0x28
 #define LIS2HH12_OUTY_L_ADDR		0x2A
 #define LIS2HH12_OUTZ_L_ADDR		0x2C
 
+
 #define LIS2HH12_FIFO_THS_ADDR			LIS2HH12_FIFO_CTRL_ADDR
+#define LIS2DW12_FIFO_THS_ADDR          LIS2HH12_FIFO_CTRL_ADDR
 #define LIS2HH12_FIFO_THS_MASK			0x1f
+#define LIS2DW12_FIFO_THS_MASK          0x1f
 
 #define LIS2HH12_FIFO_MODE_ADDR			LIS2HH12_FIFO_CTRL_ADDR
+#define LIS2DW12_FIFO_MODE_ADDR         LIS2HH12_FIFO_CTRL_ADDR
 #define LIS2HH12_FIFO_MODE_MASK			0xe0
+#define LIS2DW12_FIFO_MODE_MASK         0xe0
 #define LIS2HH12_FIFO_MODE_BYPASS		0x00
 #define LIS2HH12_FIFO_MODE_STREAM		0x02
 
@@ -54,46 +63,75 @@
 #define LIS2HH12_FIFO_SRC_FTH_MASK		0x80
 
 #define LIS2HH12_ODR_ADDR			LIS2HH12_CTRL1_ADDR
+#define LIS2DW12_ODR_ADDR           LIS2HH12_CTRL1_ADDR
 #define LIS2HH12_ODR_MASK			0x70
+#define LIS2DW12_ODR_MASK           0xF0
 #define LIS2HH12_ODR_POWER_DOWN_VAL		0x00
+#define LIS2DW12_ODR_POWER_DOWN_VAL     0x00
 #define LIS2HH12_ODR_10HZ_VAL			0x01
+#define LIS2DW12_ODR_07HZ_VAL           0x01
 #define LIS2HH12_ODR_50HZ_VAL			0x02
+#define LIS2DW12_ODR_12HZ_VAL           0x02
 #define LIS2HH12_ODR_100HZ_VAL			0x03
+#define LIS2DW12_ODR_25HZ_VAL           0x03
 #define LIS2HH12_ODR_200HZ_VAL			0x04
+#define LIS2DW12_ODR_50HZ_VAL           0x04
 #define LIS2HH12_ODR_400HZ_VAL			0x05
+#define LIS2DW12_ODR_100HZ_VAL          0x05
 #define LIS2HH12_ODR_800HZ_VAL			0x06
+#define LIS2DW12_ODR_200HZ_VAL          0x06
+#define LIS2DW12_ODR_400HZ_VAL          0x07
+#define LIS2DW12_ODR_800HZ_VAL          0x08
+#define LIS2DW12_ODR_1600HZ_VAL         0x09
 #define LIS2HH12_ODR_LIST_NUM			7
+#define LIS2DW12_ODR_LIST_NUM           9
 
 #define LIS2HH12_FS_ADDR			LIS2HH12_CTRL4_ADDR
+#define LIS2DW12_FS_ADDR            LIS2HH12_CTRL6_ADDR
 #define LIS2HH12_FS_MASK			0x30
+#define LIS2DW12_FS_MASK            0x30
 #define LIS2HH12_FS_2G_VAL			0x00
 #define LIS2HH12_FS_4G_VAL			0x02
 #define LIS2HH12_FS_8G_VAL			0x03
 #define LIS2HH12_FS_LIST_NUM		3
+#define LIS2DW12_FS_LIST_NUM        3
 
 #define LIS2HH12_FS_2G_GAIN			IIO_G_TO_M_S_2(61)
 #define LIS2HH12_FS_4G_GAIN			IIO_G_TO_M_S_2(122)
 #define LIS2HH12_FS_8G_GAIN			IIO_G_TO_M_S_2(244)
 
 #define LIS2HH12_INT_CFG_ADDR			LIS2HH12_CTRL3_ADDR
+#define LIS2DW12_INT_CFG_ADDR           0x34
 #define LIS2HH12_INT_DRDY_MASK			0x01
+#define LIS2DW12_INT_DRDY_MASK          0x01
 #define LIS2HH12_INT_FTH_MASK			0x02
+#define LIS2DW12_INT_FTH_MASK           0x02
 #define LIS2HH12_INT_FOVR_MASK			0x04
 #define LIS2HH12_INT_INACT_MASK			0x20
+#define LIS2DW12_INT_INACT_MASK         0x40
 
 #define LIS2HH12_FIFO_EN_ADDR			LIS2HH12_CTRL3_ADDR
 #define LIS2HH12_FIFO_EN_MASK			0x80
 
 #define LIS2HH12_BDU_ADDR			LIS2HH12_CTRL1_ADDR
+#define LIS2DW12_BDU_ADDR           LIS2HH12_CTRL2_ADDR
 #define LIS2HH12_BDU_MASK			0x08
+#define LIS2DW12_BDU_MASK           0x08
 #define LIS2HH12_SOFT_RESET_ADDR	LIS2HH12_CTRL5_ADDR
+#define LIS2DW12_SOFT_RESET_ADDR    LIS2HH12_CTRL2_ADDR
 #define LIS2HH12_SOFT_RESET_MASK	0x40
+#define LIS2DW12_SOFT_RESET_MASK    0x40
 #define LIS2HH12_LIR_ADDR			LIS2HH12_CTRL7_ADDR
+#define LIS2DW12_LIR_ADDR           LIS2HH12_CTRL3_ADDR
 #define LIS2HH12_LIR1_MASK			0x04
+#define LIS2DW12_LIR1_MASK			0x10
 #define LIS2HH12_LIR2_MASK			0x08
+     
 
 #define LIS2HH12_ACT_THS_MASK			0x7F
+#define LIS2DW12_ACT_THS_MASK           0x3F
 #define LIS2HH12_ACT_DUR_MASK			0xFF
+#define LIS2DW12_ACT_DUR_MASK           0xFF
 
 #define LIS2HH12_MAX_FIFO_LENGHT		32
 #define LIS2HH12_MAX_FIFO_THS			(LIS2HH12_MAX_FIFO_LENGHT - 1)
diff --git a/drivers/iio/accel/st_lis2hh12_core.c b/drivers/iio/accel/st_lis2hh12_core.c
index e63580011e33..30c9978f9236 100644
--- a/drivers/iio/accel/st_lis2hh12_core.c
+++ b/drivers/iio/accel/st_lis2hh12_core.c
@@ -29,53 +29,57 @@
 #include <linux/platform_data/st_lis2hh12.h>
 #endif
 
+/*global wai varibale used to store the whomi value*/
+
+u8 wai = 0;
+
 static const struct iio_event_spec lis2hh12_activity_events[] = {
-        {
-                .type = IIO_EV_TYPE_THRESH,
-                .dir = IIO_EV_DIR_RISING,
-                .mask_separate = BIT(IIO_EV_INFO_ENABLE) |
-                                 BIT(IIO_EV_INFO_VALUE) |
-                                 BIT(IIO_EV_INFO_PERIOD),
-         },
-        {
-                .type = IIO_EV_TYPE_THRESH,
-                .dir = IIO_EV_DIR_FALLING,
-                .mask_separate = BIT(IIO_EV_INFO_ENABLE) |
-                                 BIT(IIO_EV_INFO_VALUE) |
-                                 BIT(IIO_EV_INFO_PERIOD),
-        },
+	{
+		.type = IIO_EV_TYPE_THRESH,
+		.dir = IIO_EV_DIR_RISING,
+		.mask_separate = BIT(IIO_EV_INFO_ENABLE) |
+			BIT(IIO_EV_INFO_VALUE) |
+			BIT(IIO_EV_INFO_PERIOD),
+	},
+	{
+		.type = IIO_EV_TYPE_THRESH,
+		.dir = IIO_EV_DIR_FALLING,
+		.mask_separate = BIT(IIO_EV_INFO_ENABLE) |
+			BIT(IIO_EV_INFO_VALUE) |
+			BIT(IIO_EV_INFO_PERIOD),
+	},
 };
 #define ST_LIS2HH12_DEV_ATTR_SAMP_FREQ() \
-		IIO_DEV_ATTR_SAMP_FREQ(S_IWUSR | S_IRUGO, \
+	IIO_DEV_ATTR_SAMP_FREQ(S_IWUSR | S_IRUGO, \
 			lis2hh12_sysfs_get_sampling_frequency, \
 			lis2hh12_sysfs_set_sampling_frequency)
 
 #define ST_LIS2HH12_DEV_ATTR_SAMP_FREQ_AVAIL() \
-		IIO_DEV_ATTR_SAMP_FREQ_AVAIL( \
+	IIO_DEV_ATTR_SAMP_FREQ_AVAIL( \
 			lis2hh12_sysfs_sampling_frequency_avail)
 
 #define ST_LIS2HH12_DEV_ATTR_SCALE_AVAIL(name) \
-		IIO_DEVICE_ATTR(name, S_IRUGO, \
+	IIO_DEVICE_ATTR(name, S_IRUGO, \
 			lis2hh12_sysfs_scale_avail, NULL , 0);
 
 #define LIS2HH12_ACTIVITY_CHANNEL(_chan2, index) {                              \
-        .type = IIO_ACCEL,                                           \
-        .modified = 1,                                                  \
-        .channel2 = _chan2,                    				\
+	.type = IIO_ACCEL,                                           \
+	.modified = 1,                                                  \
+	.channel2 = _chan2,                    				\
 	.scan_index = index,			                         \
-        .info_mask_separate = BIT(IIO_CHAN_INFO_PROCESSED),             \
-        .event_spec = lis2hh12_activity_events,                          \
-        .num_event_specs = ARRAY_SIZE(lis2hh12_activity_events),         \
+	.info_mask_separate = BIT(IIO_CHAN_INFO_PROCESSED),             \
+	.event_spec = lis2hh12_activity_events,                          \
+	.num_event_specs = ARRAY_SIZE(lis2hh12_activity_events),         \
 }
-        //.ext_info = mma9553_ext_info,                                   \
+//.ext_info = mma9553_ext_info,                                   \
 
 #define LIS2HH12_ADD_CHANNEL(device_type, modif, index, mod, endian, sbits,\
-							rbits, addr, s) \
+		rbits, addr, s) \
 { \
 	.type = device_type, \
 	.modified = modif, \
 	.info_mask_separate = BIT(IIO_CHAN_INFO_RAW) | \
-			BIT(IIO_CHAN_INFO_SCALE), \
+	BIT(IIO_CHAN_INFO_SCALE), \
 	.scan_index = index, \
 	.channel2 = mod, \
 	.address = addr, \
@@ -108,6 +112,21 @@ static const struct lis2hh12_odr_table_t {
 	.odr_avl[4] = {.hz = 200,.value = LIS2HH12_ODR_200HZ_VAL,},
 	.odr_avl[5] = {.hz = 400,.value = LIS2HH12_ODR_400HZ_VAL,},
 	.odr_avl[6] = {.hz = 800,.value = LIS2HH12_ODR_800HZ_VAL,},
+},lis2dw12_odr_table = {
+	/*Changes for both the chip having different ODR add and mask*/
+	.addr = LIS2DW12_ODR_ADDR,
+	.mask = LIS2DW12_ODR_MASK,
+
+	.odr_avl[0] = {.hz = 0,.value = LIS2DW12_ODR_POWER_DOWN_VAL,},
+	.odr_avl[1] = {.hz = 7,.value = LIS2DW12_ODR_07HZ_VAL,},
+	.odr_avl[2] = {.hz = 12,.value = LIS2DW12_ODR_12HZ_VAL,},
+	.odr_avl[3] = {.hz = 25,.value = LIS2DW12_ODR_25HZ_VAL,},
+	.odr_avl[4] = {.hz = 50,.value = LIS2DW12_ODR_50HZ_VAL,},
+	.odr_avl[5] = {.hz = 100,.value = LIS2DW12_ODR_100HZ_VAL,},
+	.odr_avl[6] = {.hz = 200,.value = LIS2DW12_ODR_200HZ_VAL,},
+//	.odr_avl[7] = {.hz = 400,.value = LIS2DW12_ODR_400HZ_VAL,},
+//	.odr_avl[8] = {.hz = 800,.value = LIS2DW12_ODR_800HZ_VAL,},
+//	.odr_avl[9] = {.hz = 1600,.value = LIS2DW12_ODR_1600HZ_VAL,},
 };
 
 struct lis2hh12_fs_reg {
@@ -122,6 +141,23 @@ static struct lis2hh12_fs_table {
 } lis2hh12_fs_table = {
 	.addr = LIS2HH12_FS_ADDR,
 	.mask = LIS2HH12_FS_MASK,
+
+	.fs_avl[0] = {
+		.gain = LIS2HH12_FS_2G_GAIN,
+		.value = LIS2HH12_FS_2G_VAL,
+	},
+	.fs_avl[1] = {
+		.gain = LIS2HH12_FS_4G_GAIN,
+		.value = LIS2HH12_FS_4G_VAL,
+	},
+	.fs_avl[2] = {
+		.gain = LIS2HH12_FS_8G_GAIN,
+		.value = LIS2HH12_FS_8G_VAL,
+	},
+},lis2dw12_fs_table = {
+	.addr = LIS2DW12_FS_ADDR,
+	.mask = LIS2DW12_FS_MASK,
+
 	.fs_avl[0] = {
 		.gain = LIS2HH12_FS_2G_GAIN,
 		.value = LIS2HH12_FS_2G_VAL,
@@ -141,9 +177,6 @@ const struct iio_event_spec lis2hh12_fifo_flush_event = {
 	.dir = IIO_EV_DIR_EITHER,
 };
 
-
-
-
 static const struct lis2hh12_sensors_table {
 	const char *name;
 	const char *description;
@@ -171,13 +204,13 @@ static const struct lis2hh12_sensors_table {
 
 
 inline int lis2hh12_read_register(struct lis2hh12_data *cdata, u8 reg_addr, int data_len,
-							u8 *data)
+		u8 *data)
 {
 	return cdata->tf->read(cdata, reg_addr, data_len, data);
 }
 
 static int lis2hh12_write_register(struct lis2hh12_data *cdata, u8 reg_addr,
-							u8 mask, u8 data)
+		u8 mask, u8 data)
 {
 	int err;
 	u8 new_data = 0x00, old_data = 0x00;
@@ -201,31 +234,37 @@ int lis2hh12_set_fifo_mode(struct lis2hh12_data *cdata, enum fifo_mode fm)
 	struct timespec ts;
 
 	switch (fm) {
-	case BYPASS:
-		reg_value = LIS2HH12_FIFO_MODE_BYPASS;
-		set_bit = LIS2HH12_DIS_BIT;
-		break;
-	case STREAM:
-		reg_value = LIS2HH12_FIFO_MODE_STREAM;
-		set_bit = LIS2HH12_EN_BIT;
-		break;
-	default:
-		return -EINVAL;
+		case BYPASS:
+			reg_value = LIS2HH12_FIFO_MODE_BYPASS;
+			set_bit = LIS2HH12_DIS_BIT;
+			break;
+		case STREAM:
+			reg_value = LIS2HH12_FIFO_MODE_STREAM;
+			set_bit = LIS2HH12_EN_BIT;
+			break;
+		default:
+			return -EINVAL;
 	}
 
+	/*FIFO_MODE_ADD and FIFO_MODE_MASK is same for the both acc chip*/
 	err = lis2hh12_write_register(cdata, LIS2HH12_FIFO_MODE_ADDR,
-				LIS2HH12_FIFO_MODE_MASK, reg_value);
-
+			LIS2HH12_FIFO_MODE_MASK, reg_value);
 	if (err < 0)
 		return err;
 
 	get_monotonic_boottime(&ts);
 	cdata->sensor_timestamp = timespec_to_ns(&ts);
 
-	err = lis2hh12_write_register(cdata, LIS2HH12_FIFO_EN_ADDR,
+	/*Execute this function only for the HH12 acc chip and not required for the DW12*/
+	if(wai == LIS2HH12_WHO_AM_I_DEF)
+	{ 
+		err = lis2hh12_write_register(cdata, LIS2HH12_FIFO_EN_ADDR,
 				LIS2HH12_FIFO_EN_MASK, set_bit);
-	if (err < 0)
-		return err;
+		if (err < 0)
+		{
+			return err;
+		}
+	}
 
 	return 0;
 }
@@ -244,25 +283,54 @@ int lis2hh12_write_max_odr(struct lis2hh12_sensor_data *sdata)
 				max_odr = t_sdata->odr;
 		}
 
-	if (max_odr != sdata->cdata->common_odr) {
-		for (i = 0; i < LIS2HH12_ODR_LIST_NUM; i++) {
-			if (lis2hh12_odr_table.odr_avl[i].hz >= max_odr)
-				break;
+	if(wai == LIS2HH12_WHO_AM_I_DEF)
+	{
+		if (max_odr != sdata->cdata->common_odr) 
+		{
+			for (i = 0; i < LIS2HH12_ODR_LIST_NUM; i++) 
+			{
+				if (lis2hh12_odr_table.odr_avl[i].hz >= max_odr)
+					break;
+			}
+			if (i == LIS2HH12_ODR_LIST_NUM)
+				return -EINVAL;
+
+			err = lis2hh12_write_register(sdata->cdata,
+					lis2hh12_odr_table.addr,
+					lis2hh12_odr_table.mask,
+					lis2hh12_odr_table.odr_avl[i].value);
+			if (err < 0)
+				return err;
+
+
+			sdata->cdata->common_odr = max_odr;
+			sdata->cdata->sensor_deltatime = (max_odr) ? 1000000000L / max_odr : 0;
 		}
-		if (i == LIS2HH12_ODR_LIST_NUM)
-			return -EINVAL;
-
-		err = lis2hh12_write_register(sdata->cdata,
-				lis2hh12_odr_table.addr,
-				lis2hh12_odr_table.mask,
-				lis2hh12_odr_table.odr_avl[i].value);
-		if (err < 0)
-			return err;
-
-		sdata->cdata->common_odr = max_odr;
-		sdata->cdata->sensor_deltatime = (max_odr) ? 1000000000L / max_odr : 0;
 	}
-
+	else if(wai == LIS2DW12_WHO_AM_I_DEF)
+	{
+		if (max_odr != sdata->cdata->common_odr) 
+		{
+			for (i = 0; i < LIS2DW12_ODR_LIST_NUM; i++) 
+			{
+				if (lis2dw12_odr_table.odr_avl[i].hz >= max_odr)
+					break;
+			}
+			if (i == LIS2DW12_ODR_LIST_NUM)
+				return -EINVAL;
+
+			err = lis2hh12_write_register(sdata->cdata,
+					lis2dw12_odr_table.addr,
+					lis2dw12_odr_table.mask,
+					lis2dw12_odr_table.odr_avl[i].value);
+			if (err < 0)
+				return err;
+
+
+			sdata->cdata->common_odr = max_odr;
+			sdata->cdata->sensor_deltatime = (max_odr) ? 1000000000L / max_odr : 0;
+		} 
+	}
 	return 0;
 }
 
@@ -270,22 +338,47 @@ int lis2hh12_set_fs(struct lis2hh12_sensor_data *sdata, unsigned int gain)
 {
 	int err, i;
 
-	for (i = 0; i < LIS2HH12_FS_LIST_NUM; i++) {
-		if (lis2hh12_fs_table.fs_avl[i].gain == gain)
-			break;
-	}
+	/*Condition for the HH12 acc chip*/
+	if(wai == LIS2HH12_WHO_AM_I_DEF)
+	{
+		for (i = 0; i < LIS2HH12_FS_LIST_NUM; i++) {
+			if (lis2hh12_fs_table.fs_avl[i].gain == gain)
+				break;
+		}
 
-	if (i == LIS2HH12_FS_LIST_NUM)
-		return -EINVAL;
+		if (i == LIS2HH12_FS_LIST_NUM)
+			return -EINVAL;
 
-	err = lis2hh12_write_register(sdata->cdata,
+		err = lis2hh12_write_register(sdata->cdata,
 				lis2hh12_fs_table.addr, lis2hh12_fs_table.mask,
 				lis2hh12_fs_table.fs_avl[i].value);
-	if (err < 0)
-		return err;
+		if (err < 0)
+			return err;
+
+
+		sdata->gain = lis2hh12_fs_table.fs_avl[i].gain;
+	}
+	/*Condition for the DW12 acc chip*/
+	else if(wai == LIS2DW12_WHO_AM_I_DEF)
+	{
+		for (i = 0; i < LIS2DW12_FS_LIST_NUM; i++) {
+			if (lis2dw12_fs_table.fs_avl[i].gain == gain)
+				break;
+		}
+
+		if (i == LIS2DW12_FS_LIST_NUM)
+			return -EINVAL;
+
+
+		err = lis2hh12_write_register(sdata->cdata,
+				lis2dw12_fs_table.addr, lis2dw12_fs_table.mask,
+				lis2dw12_fs_table.fs_avl[i].value);
+		if (err < 0)
+			return err;
 
-	sdata->gain = lis2hh12_fs_table.fs_avl[i].gain;
 
+		sdata->gain = lis2hh12_fs_table.fs_avl[i].gain;
+	}
 	return 0;
 }
 
@@ -294,23 +387,37 @@ int lis2hh12_update_drdy_irq(struct lis2hh12_sensor_data *sdata, bool state)
 	u8 reg_addr, reg_val, reg_mask;
 
 	switch (sdata->sindex) {
-	case LIS2HH12_ACCEL:
-		//reg_addr = LIS2HH12_INT_CFG_ADDR;
-		reg_addr = LIS2HH12_CTRL6_ADDR;
-		if (sdata->cdata->hwfifo_enabled)
-			reg_mask = (LIS2HH12_INT_FTH_MASK);
-		else
-			reg_mask = (LIS2HH12_INT_DRDY_MASK);
-
-		if (state)
-			reg_val = LIS2HH12_EN_BIT;
-		else
-			reg_val = LIS2HH12_DIS_BIT;
-
-		break;
-
-	default:
-		return -EINVAL;
+		case LIS2HH12_ACCEL:
+			//reg_addr = LIS2HH12_INT_CFG_ADDR;
+
+			/*Condition for the HH12 acc chip*/
+			if(wai == LIS2HH12_WHO_AM_I_DEF)
+			{
+				reg_addr = LIS2HH12_CTRL6_ADDR;
+				if (sdata->cdata->hwfifo_enabled)
+					reg_mask = (LIS2HH12_INT_FTH_MASK);
+				else
+					reg_mask = (LIS2HH12_INT_DRDY_MASK);
+			}
+			/*Condition for the DW12 acc chip*/
+			else if(wai == LIS2DW12_WHO_AM_I_DEF)
+			{
+				reg_addr = LIS2HH12_CTRL5_ADDR;
+				if (sdata->cdata->hwfifo_enabled)
+					reg_mask = (LIS2DW12_INT_FTH_MASK);
+				else
+					reg_mask = (LIS2DW12_INT_DRDY_MASK);
+			}
+
+			if (state)
+				reg_val = LIS2HH12_EN_BIT;
+			else
+				reg_val = LIS2HH12_DIS_BIT;
+
+			break;
+
+		default:
+			return -EINVAL;
 	}
 
 	return lis2hh12_write_register(sdata->cdata, reg_addr, reg_mask, reg_val);
@@ -339,9 +446,10 @@ int lis2hh12_update_fifo_ths(struct lis2hh12_data *cdata, u8 fifo_len)
 
 	indio_dev = cdata->iio_sensors_dev[LIS2HH12_ACCEL];
 
+	/*FIFO_THS_ADDR and FIFO_THS_MASK value is same for both the acc chip*/
 	err = lis2hh12_write_register(cdata, LIS2HH12_FIFO_THS_ADDR,
-				LIS2HH12_FIFO_THS_MASK,
-				fifo_len);
+			LIS2HH12_FIFO_THS_MASK,
+			fifo_len);
 	if (err < 0)
 		return err;
 
@@ -403,38 +511,75 @@ int lis2hh12_init_sensors(struct lis2hh12_data *cdata)
 	/*
 	 * Soft reset the device on power on.
 	 */
-	err = lis2hh12_write_register(cdata, LIS2HH12_SOFT_RESET_ADDR,
+
+	if(wai == LIS2HH12_WHO_AM_I_DEF)       /*Condition for the HH12 acc chip*/
+	{
+		err = lis2hh12_write_register(cdata, LIS2HH12_SOFT_RESET_ADDR,
 				LIS2HH12_SOFT_RESET_MASK,
 				LIS2HH12_EN_BIT);
-	if (err < 0)
-		return err;
+		if (err < 0)
+			return err;
+	}
+	else if(wai == LIS2DW12_WHO_AM_I_DEF)   /*Condition for the DW12 acc chip*/
+	{
+		err = lis2hh12_write_register(cdata, LIS2DW12_SOFT_RESET_ADDR,
+				LIS2DW12_SOFT_RESET_MASK,
+				LIS2HH12_EN_BIT);
+		if (err < 0)
+			return err;
+	}
 
 	mdelay(40);
 
 	/*
 	 * Enable latched interrupt mode on INT1.
 	 */
-	err = lis2hh12_write_register(cdata, LIS2HH12_LIR_ADDR,
+
+	if(wai == LIS2HH12_WHO_AM_I_DEF)       /*Condition for the HH12 acc chip*/
+	{
+		err = lis2hh12_write_register(cdata, LIS2HH12_LIR_ADDR,
 				LIS2HH12_LIR1_MASK,
 				LIS2HH12_EN_BIT);
-	if (err < 0)
-		return err;
+		if (err < 0)
+			return err;
+	}
+	else if(wai == LIS2DW12_WHO_AM_I_DEF)  /*Condition for the DW12 acc chip*/
+	{
+		err = lis2hh12_write_register(cdata, LIS2DW12_LIR_ADDR,
+				LIS2DW12_LIR1_MASK,
+				LIS2HH12_EN_BIT);
+		if (err < 0)
+			return err;
+
+	}
 
 	/*
 	 * Enable block data update feature.
 	 */
-	err = lis2hh12_write_register(cdata, LIS2HH12_BDU_ADDR,
+
+	if(wai == LIS2HH12_WHO_AM_I_DEF)    /*Condition for the HH12 acc chip*/
+	{
+		err = lis2hh12_write_register(cdata, LIS2HH12_BDU_ADDR,
 				LIS2HH12_BDU_MASK,
 				LIS2HH12_EN_BIT);
-	if (err < 0)
-		return err;
+		if (err < 0)
+			return err;
+	}
+	else if(wai == LIS2DW12_WHO_AM_I_DEF)   /*Condition for the DW12 acc chip*/
+	{
+		err = lis2hh12_write_register(cdata, LIS2DW12_BDU_ADDR,
+				LIS2DW12_BDU_MASK,
+				LIS2HH12_EN_BIT);
+		if (err < 0)
+			return err;
+	}
 
 	return 0;
 }
 
 static ssize_t lis2hh12_sysfs_get_sampling_frequency(struct device *dev,
-					struct device_attribute *attr,
-					char *buf)
+		struct device_attribute *attr,
+		char *buf)
 {
 	struct lis2hh12_sensor_data *sdata = iio_priv(dev_get_drvdata(dev));
 
@@ -456,36 +601,73 @@ ssize_t lis2hh12_sysfs_set_sampling_frequency(struct device * dev,
 
 	if (sdata->odr == odr)
 		return count;
+	/*Condition for the HH12 acc chip*/
+	if(wai == LIS2HH12_WHO_AM_I_DEF)
+	{
+		mode_count = LIS2HH12_ODR_LIST_NUM;
+
+		for (i = 0; i < mode_count; i++) 
+		{
+			if (lis2hh12_odr_table.odr_avl[i].hz >= odr)
+				break;
+		}
+		if (i == LIS2HH12_ODR_LIST_NUM)
+			return -EINVAL;
 
-	mode_count = LIS2HH12_ODR_LIST_NUM;
+		mutex_lock(&indio_dev->mlock);
+		sdata->odr = lis2hh12_odr_table.odr_avl[i].hz;
+		mutex_unlock(&indio_dev->mlock);
 
-	for (i = 0; i < mode_count; i++) {
-		if (lis2hh12_odr_table.odr_avl[i].hz >= odr)
-			break;
+		err = lis2hh12_write_max_odr(sdata);
+		if (err < 0)
+			return err;
 	}
-	if (i == LIS2HH12_ODR_LIST_NUM)
-		return -EINVAL;
-
-	mutex_lock(&indio_dev->mlock);
-	sdata->odr = lis2hh12_odr_table.odr_avl[i].hz;
-	mutex_unlock(&indio_dev->mlock);
+	/*Condition for the DW12 acc chip*/
+	else if(wai == LIS2DW12_WHO_AM_I_DEF)
+	{
+		mode_count = LIS2DW12_ODR_LIST_NUM;
+
+		for (i = 0; i < mode_count; i++) 
+		{
+			if (lis2dw12_odr_table.odr_avl[i].hz >= odr)
+				break;
+		}
+		if (i == LIS2DW12_ODR_LIST_NUM)
+			return -EINVAL;
 
-	err = lis2hh12_write_max_odr(sdata);
-	if (err < 0)
-		return err;
+		mutex_lock(&indio_dev->mlock);
+		sdata->odr = lis2dw12_odr_table.odr_avl[i].hz;
+		mutex_unlock(&indio_dev->mlock);
 
+		err = lis2hh12_write_max_odr(sdata);
+		if (err < 0)
+			return err;
+	}
 	return (err < 0) ? err : count;
 }
 
 static ssize_t lis2hh12_sysfs_sampling_frequency_avail(struct device *dev,
-						struct device_attribute
-						*attr, char *buf)
+		struct device_attribute
+		*attr, char *buf)
 {
 	int i, len = 0;
-
-	for (i = 0; i < LIS2HH12_ODR_LIST_NUM; i++) {
-		len += scnprintf(buf + len, PAGE_SIZE - len, "%d ",
-				lis2hh12_odr_table.odr_avl[i].hz);
+	/*Condition for the HH12 acc chip*/
+	if(wai == LIS2HH12_WHO_AM_I_DEF)
+	{
+		for (i = 0; i < LIS2HH12_ODR_LIST_NUM; i++) 
+		{
+			len += scnprintf(buf + len, PAGE_SIZE - len, "%d ",
+					lis2hh12_odr_table.odr_avl[i].hz);
+		}
+	}
+	/*Condition for the DW12 acc chip*/
+	else if(wai == LIS2DW12_WHO_AM_I_DEF)
+	{
+		for (i = 0; i < LIS2DW12_ODR_LIST_NUM; i++) 
+		{
+			len += scnprintf(buf + len, PAGE_SIZE - len, "%d ",
+					lis2dw12_odr_table.odr_avl[i].hz);
+		}
 	}
 	buf[len - 1] = '\n';
 
@@ -493,13 +675,26 @@ static ssize_t lis2hh12_sysfs_sampling_frequency_avail(struct device *dev,
 }
 
 static ssize_t lis2hh12_sysfs_scale_avail(struct device *dev,
-				struct device_attribute *attr, char *buf)
+		struct device_attribute *attr, char *buf)
 {
 	int i, len = 0;
-
-	for (i = 0; i < LIS2HH12_FS_LIST_NUM; i++) {
-		len += scnprintf(buf + len, PAGE_SIZE - len, "0.%06u ",
-			lis2hh12_fs_table.fs_avl[i].gain);
+	/*Condition for the HH12 acc chip*/
+	if(wai == LIS2HH12_WHO_AM_I_DEF)
+	{
+		for (i = 0; i < LIS2HH12_FS_LIST_NUM; i++) 
+		{
+			len += scnprintf(buf + len, PAGE_SIZE - len, "0.%06u ",
+					lis2hh12_fs_table.fs_avl[i].gain);
+		}
+	}
+	/*Condition for the DW12 acc chip*/
+	else if(wai == LIS2DW12_WHO_AM_I_DEF)
+	{
+		for (i = 0; i < LIS2DW12_FS_LIST_NUM; i++) 
+		{
+			len += scnprintf(buf + len, PAGE_SIZE - len, "0.%06u ",
+					lis2dw12_fs_table.fs_avl[i].gain);
+		}
 	}
 	buf[len - 1] = '\n';
 
@@ -508,8 +703,8 @@ static ssize_t lis2hh12_sysfs_scale_avail(struct device *dev,
 
 
 static int lis2hh12_reg_access(struct iio_dev *indio_dev,
-                        unsigned reg, unsigned writeval,
-                        unsigned *readval)
+		unsigned reg, unsigned writeval,
+		unsigned *readval)
 {
 	int err = 0;
 	struct lis2hh12_sensor_data *sdata = iio_priv(indio_dev);
@@ -525,11 +720,11 @@ static int lis2hh12_reg_access(struct iio_dev *indio_dev,
 		mdelay(40);
 	} else {
 		/*
-        	* Read dev reg
-        	*/
-        	err = lis2hh12_read_register(sdata->cdata, reg , 1, (u8 *)readval);
-        	if (err < 0)
-        	        return err;
+		 * Read dev reg
+		 */
+		err = lis2hh12_read_register(sdata->cdata, reg , 1, (u8 *)readval);
+		if (err < 0)
+			return err;
 
 	}
 	return 0;
@@ -563,7 +758,7 @@ ssize_t lis2hh12_sysfs_flush_fifo(struct device *dev,
 
 	iio_push_event(indio_dev, IIO_UNMOD_EVENT_CODE(IIO_ACCEL,
 				-1, IIO_EV_TYPE_FIFO_FLUSH, event_type),
-				sdata->cdata->sensor_timestamp);
+			sdata->cdata->sensor_timestamp);
 
 	enable_irq(sdata->cdata->irq);
 	mutex_unlock(&indio_dev->mlock);
@@ -572,7 +767,7 @@ ssize_t lis2hh12_sysfs_flush_fifo(struct device *dev,
 }
 
 static ssize_t lis2hh12_sysfs_get_hwfifo_enabled(struct device *dev,
-				struct device_attribute *attr, char *buf)
+		struct device_attribute *attr, char *buf)
 {
 	struct iio_dev *indio_dev = dev_get_drvdata(dev);
 	struct lis2hh12_sensor_data *sdata = iio_priv(indio_dev);
@@ -590,7 +785,7 @@ ssize_t lis2hh12_sysfs_set_hwfifo_enabled(struct device * dev,
 
 	err = kstrtoint(buf, 10, &enable);
 	if (err < 0)
-			return err;
+		return err;
 
 	if (enable != 0x0 && enable != 0x1)
 		return -EINVAL;
@@ -607,7 +802,7 @@ ssize_t lis2hh12_sysfs_set_hwfifo_enabled(struct device * dev,
 }
 
 static ssize_t lis2hh12_sysfs_get_hwfifo_watermark(struct device *dev,
-				struct device_attribute *attr, char *buf)
+		struct device_attribute *attr, char *buf)
 {
 	struct iio_dev *indio_dev = dev_get_drvdata(dev);
 	struct lis2hh12_sensor_data *sdata = iio_priv(indio_dev);
@@ -624,7 +819,7 @@ ssize_t lis2hh12_sysfs_set_hwfifo_watermark(struct device * dev,
 
 	err = kstrtoint(buf, 10, &watermark);
 	if (err < 0)
-			return err;
+		return err;
 
 	if ((watermark < 1) || (watermark > LIS2HH12_MAX_FIFO_THS))
 		return -EINVAL;
@@ -639,69 +834,69 @@ ssize_t lis2hh12_sysfs_set_hwfifo_watermark(struct device * dev,
 }
 
 static ssize_t lis2hh12_sysfs_get_hwfifo_watermark_min(struct device *dev,
-				struct device_attribute *attr, char *buf)
+		struct device_attribute *attr, char *buf)
 {
 	return sprintf(buf, "%d\n", 1);
 }
 
 static ssize_t lis2hh12_sysfs_get_hwfifo_watermark_max(struct device *dev,
-				struct device_attribute *attr, char *buf)
+		struct device_attribute *attr, char *buf)
 {
 	return sprintf(buf, "%d\n", LIS2HH12_MAX_FIFO_THS);
 }
 
 static int lis2hh12_read_raw(struct iio_dev *indio_dev,
-			struct iio_chan_spec const *ch, int *val,
-							int *val2, long mask)
+		struct iio_chan_spec const *ch, int *val,
+		int *val2, long mask)
 {
 	int err;
 	u8 outdata[2], nbytes;
 	struct lis2hh12_sensor_data *sdata = iio_priv(indio_dev);
-	
+
 
 	switch (mask) {
-	case IIO_CHAN_INFO_RAW:
-		mutex_lock(&indio_dev->mlock);
-		if (indio_dev->currentmode == INDIO_BUFFER_TRIGGERED) {
-			mutex_unlock(&indio_dev->mlock);
-			return -EBUSY;
-		}
+		case IIO_CHAN_INFO_RAW:
+			mutex_lock(&indio_dev->mlock);
+			if (indio_dev->currentmode == INDIO_BUFFER_TRIGGERED) {
+				mutex_unlock(&indio_dev->mlock);
+				return -EBUSY;
+			}
 
-		err = lis2hh12_set_enable(sdata, true);
-		if (err < 0) {
-			mutex_unlock(&indio_dev->mlock);
-			return -EBUSY;
-		}
+			err = lis2hh12_set_enable(sdata, true);
+			if (err < 0) {
+				mutex_unlock(&indio_dev->mlock);
+				return -EBUSY;
+			}
 
-		msleep(40);
+			msleep(40);
 
-		nbytes = ch->scan_type.realbits / 8;
+			nbytes = ch->scan_type.realbits / 8;
 
-		err = lis2hh12_read_register(sdata->cdata, ch->address, nbytes, outdata);
-		if (err < 0) {
-			mutex_unlock(&indio_dev->mlock);
-			return err;
-		}
+			err = lis2hh12_read_register(sdata->cdata, ch->address, nbytes, outdata);
+			if (err < 0) {
+				mutex_unlock(&indio_dev->mlock);
+				return err;
+			}
 
-		*val = (s16)get_unaligned_le16(outdata);
-		*val = *val >> ch->scan_type.shift;
+			*val = (s16)get_unaligned_le16(outdata);
+			*val = *val >> ch->scan_type.shift;
 
-		err = lis2hh12_set_enable(sdata, false);
-		mutex_unlock(&indio_dev->mlock);
+			err = lis2hh12_set_enable(sdata, false);
+			mutex_unlock(&indio_dev->mlock);
 
-		if (err < 0)
-			return err;
+			if (err < 0)
+				return err;
 
-		return IIO_VAL_INT;
+			return IIO_VAL_INT;
 
-	case IIO_CHAN_INFO_SCALE:
-		*val = 0;
-		*val2 = sdata->gain;
+		case IIO_CHAN_INFO_SCALE:
+			*val = 0;
+			*val2 = sdata->gain;
 
-		return IIO_VAL_INT_PLUS_MICRO;
+			return IIO_VAL_INT_PLUS_MICRO;
 
-	default:
-		return -EINVAL;
+		default:
+			return -EINVAL;
 	}
 
 	return 0;
@@ -715,182 +910,298 @@ static int lis2hh12_write_raw(struct iio_dev *indio_dev,
 
 
 	switch (mask) {
-	case IIO_CHAN_INFO_SCALE:
-		mutex_lock(&indio_dev->mlock);
-
-		if (indio_dev->currentmode == INDIO_BUFFER_TRIGGERED) {
-			mutex_unlock(&indio_dev->mlock);
-			return -EBUSY;
-		}
+		case IIO_CHAN_INFO_SCALE:
+			mutex_lock(&indio_dev->mlock);
+
+			if (indio_dev->currentmode == INDIO_BUFFER_TRIGGERED) {
+				mutex_unlock(&indio_dev->mlock);
+				return -EBUSY;
+			}
+			/*Condition for the HH12 acc chip*/
+			if(wai == LIS2HH12_WHO_AM_I_DEF)
+			{
+				for (i = 0; i < LIS2HH12_FS_LIST_NUM; i++) 
+				{
+					if (lis2hh12_fs_table.fs_avl[i].gain == val2)
+						break;
+				}
+
+				err = lis2hh12_set_fs(sdata, lis2hh12_fs_table.fs_avl[i].gain);
+				mutex_unlock(&indio_dev->mlock);
+			}
+			/*Condition for the DW12 acc chip*/
+			else if(wai == LIS2DW12_WHO_AM_I_DEF)
+			{
+				for (i = 0; i < LIS2DW12_FS_LIST_NUM; i++) 
+				{
+					if (lis2dw12_fs_table.fs_avl[i].gain == val2)
+						break;
+				}
+
+				err = lis2hh12_set_fs(sdata, lis2dw12_fs_table.fs_avl[i].gain);
+				mutex_unlock(&indio_dev->mlock);
+			}
 
-		for (i = 0; i < LIS2HH12_FS_LIST_NUM; i++) {
-			if (lis2hh12_fs_table.fs_avl[i].gain == val2)
-				break;
-		}
-
-		err = lis2hh12_set_fs(sdata, lis2hh12_fs_table.fs_avl[i].gain);
-		mutex_unlock(&indio_dev->mlock);
-
-		break;
+			break;
 
-	default:
-		return -EINVAL;
+		default:
+			return -EINVAL;
 	}
 
 	return err;
 }
 
 /* VT : this is extra support added in addition to gen reg read / write
-        When full support required, supoprt for separte event infor structure 
-        should be added. */
+   When full support required, supoprt for separte event infor structure 
+   should be added. */
 static bool activityEnabled = false;
 
 static int lis2hh12_read_event_config(struct iio_dev *indio_dev,
-                                     const struct iio_chan_spec *chan,
-                                     enum iio_event_type type,
-                                     enum iio_event_direction dir)
+		const struct iio_chan_spec *chan,
+		enum iio_event_type type,
+		enum iio_event_direction dir)
 {
 	return activityEnabled;
 }
 
 static int lis2hh12_write_event_config(struct iio_dev *indio_dev,
-                                      const struct iio_chan_spec *chan,
-                                      enum iio_event_type type,
-                                      enum iio_event_direction dir, int state)
+		const struct iio_chan_spec *chan,
+		enum iio_event_type type,
+		enum iio_event_direction dir, int state)
 {
 	int err = 0;
-        struct lis2hh12_sensor_data *sdata = iio_priv(indio_dev);
+	struct lis2hh12_sensor_data *sdata = iio_priv(indio_dev);
 
 	if (state) {
 		printk("Vol : Enabling inactivity interrupt.. \r\n");
 		/*
-        	* Change ODR of LIS2HH12 to 10 Hz to start its op.
-        	*/
-        	err = lis2hh12_write_register(sdata->cdata, LIS2HH12_ODR_ADDR,
-        	                        LIS2HH12_ODR_MASK,
-        	                        0x01);
-        	if (err < 0)
-        	        return err;
+		 * Change ODR of LIS2HH12 to 10 Hz to start its op.
+		 */
+		/*Condition for the HH12 acc chip*/
+		if(wai == LIS2HH12_WHO_AM_I_DEF)
+		{
+			err = lis2hh12_write_register(sdata->cdata, LIS2HH12_ODR_ADDR,
+					LIS2HH12_ODR_MASK,
+					0x01);
+			if (err < 0)
+				return err;
+		}
+		/*Condition for the DW12 acc chip*/
+		else if(wai == LIS2DW12_WHO_AM_I_DEF)
+		{
+			err = lis2hh12_write_register(sdata->cdata, LIS2DW12_ODR_ADDR,
+					LIS2DW12_ODR_MASK,
+					0x01);
+			if (err < 0)
+				return err;
+
+		}
 
 		/*
-        	* Enable interrupt for inactivity
-        	*/
-        	err = lis2hh12_write_register(sdata->cdata, LIS2HH12_INT_CFG_ADDR,
-        	                        LIS2HH12_INT_INACT_MASK,
-        	                        0x01);
-        	if (err < 0)
-        	        return err;
-
-                mutex_lock(&indio_dev->mlock);
+		 * Enable interrupt for inactivity
+		 */
+		/*Condition required for the HH12 acc chip*/
+		if(wai == LIS2HH12_WHO_AM_I_DEF)
+		{
+			err = lis2hh12_write_register(sdata->cdata, LIS2HH12_INT_CFG_ADDR,
+					LIS2HH12_INT_INACT_MASK,
+					0x01);
+			if (err < 0)
+				return err;
+		}
+		/*Condition required for the DW12 acc chip*/
+		else if (wai == LIS2DW12_WHO_AM_I_DEF)
+		{
+			err = lis2hh12_write_register(sdata->cdata, LIS2DW12_INT_CFG_ADDR,
+					LIS2DW12_INT_INACT_MASK,
+					0x01);
+			if (err < 0)
+				return err;
+		}
+
+		mutex_lock(&indio_dev->mlock);
 		activityEnabled = true;
-                mutex_unlock(&indio_dev->mlock);
+		mutex_unlock(&indio_dev->mlock);
 	} else {
 		printk("Vol : Disabling inactivity interrupt.. \r\n");
 		/*
-        	* Disable interrupt for inactivity
-        	*/
-        	err = lis2hh12_write_register(sdata->cdata, LIS2HH12_INT_INACT_MASK,
-        	                        LIS2HH12_INT_INACT_MASK,
-        	                        0x00);
-        	if (err < 0)
-        	        return err;
+		 * Disable interrupt for inactivity
+		 */
+		/*Condition required for the HH12 acc chip*/
+		if(wai == LIS2HH12_WHO_AM_I_DEF)
+		{
+			err = lis2hh12_write_register(sdata->cdata, LIS2HH12_INT_INACT_MASK,
+					LIS2HH12_INT_INACT_MASK,
+					0x00);
+			if (err < 0)
+				return err;
+		}
+		/*Condition for the DW12 acc chip*/
+		else if(wai == LIS2DW12_WHO_AM_I_DEF)
+		{
+			err = lis2hh12_write_register(sdata->cdata, LIS2DW12_INT_INACT_MASK,
+					LIS2DW12_INT_INACT_MASK,
+					0x00);
+			if (err < 0)
+				return err;
+		}
 		/*
-        	* Change ODR of LIS2HH12 0 to disable op.
-        	*/
-        	err = lis2hh12_write_register(sdata->cdata, LIS2HH12_ODR_ADDR,
-        	                        LIS2HH12_ODR_MASK,
-        	                        0x00);
-        	if (err < 0)
-        	        return err;
-		
-                mutex_lock(&indio_dev->mlock);
+		 * Change ODR of LIS2HH12 0 to disable op.
+		 */
+		if(wai == LIS2HH12_WHO_AM_I_DEF)
+		{
+			err = lis2hh12_write_register(sdata->cdata, LIS2HH12_ODR_ADDR,
+					LIS2HH12_ODR_MASK,
+					0x00);
+			if (err < 0)
+				return err;
+		}
+		else if(wai == LIS2DW12_WHO_AM_I_DEF)
+		{
+			err = lis2hh12_write_register(sdata->cdata, LIS2DW12_ODR_ADDR,
+					LIS2DW12_ODR_MASK,
+					0x00);
+			if (err < 0)
+				return err;
+		}
+
+		mutex_lock(&indio_dev->mlock);
 		activityEnabled = false;
-                mutex_unlock(&indio_dev->mlock);
+		mutex_unlock(&indio_dev->mlock);
 	}
 	return 0;
 }
 
 
 static int lis2hh12_read_event_value(struct iio_dev *indio_dev,
-                                    const struct iio_chan_spec *chan,
-                                    enum iio_event_type type,
-                                    enum iio_event_direction dir,
-                                    enum iio_event_info info,
-                                    int *val, int *val2)
+		const struct iio_chan_spec *chan,
+		enum iio_event_type type,
+		enum iio_event_direction dir,
+		enum iio_event_info info,
+		int *val, int *val2)
 {
 	int err = 0;
-        struct lis2hh12_sensor_data *sdata = iio_priv(indio_dev);
+	struct lis2hh12_sensor_data *sdata = iio_priv(indio_dev);
 
 	switch(info) {
-		case IIO_EV_INFO_VALUE: 
-        		err = lis2hh12_read_register(sdata->cdata, LIS2HH12_ACT_THS_ADDR,
-        		                        1,
-        		                        (u8 *)val);
-        		if (err < 0)
-        		        return err;
-
-        		mdelay(40);
+		case IIO_EV_INFO_VALUE:
+			if(wai ==  LIS2HH12_WHO_AM_I_DEF)  /*Condition for the HH12 acc chip*/
+			{
+				err = lis2hh12_read_register(sdata->cdata, LIS2HH12_ACT_THS_ADDR,
+						1,
+						(u8 *)val);
+				if (err < 0)
+					return err;
+			}
+			else if(wai == LIS2DW12_WHO_AM_I_DEF)      /*Condition for the DW12 acc chip*/
+			{
+				err = lis2hh12_read_register(sdata->cdata, LIS2DW12_WAKE_UP_THS_ADDR,
+						1,
+						(u8 *)val);
+				if (err < 0)
+					return err;
+
+			}
+
+			mdelay(40);
 			break;
 
 		case IIO_EV_INFO_PERIOD:
-        		err = lis2hh12_read_register(sdata->cdata, LIS2HH12_ACT_DUR_ADDR,
-        		                        1,
-        		                        (u8 *)val);
-        		if (err < 0)
-        		        return err;
-
-        		mdelay(40);
+			if(wai == LIS2HH12_WHO_AM_I_DEF) /*Condition for the HH12 acc chip*/
+			{
+				err = lis2hh12_read_register(sdata->cdata, LIS2HH12_ACT_DUR_ADDR,
+						1,
+						(u8 *)val);
+				if (err < 0)
+					return err;
+			}
+			else if(wai == LIS2DW12_WHO_AM_I_DEF)   /*Condition for the DW12 acc chip*/
+			{
+				err = lis2hh12_read_register(sdata->cdata, LIS2DW12_WAKE_UP_DUR_ADDR,
+						1,
+						(u8 *)val);
+				if (err < 0)
+					return err;
+
+			}
+
+			mdelay(40);
 			break; 
 
 		default:
-		 printk("Default read case\r\n");
-		 break;
+			printk("Default read case\r\n");
+			break;
 	}
 
-        return 0;
-	
+	return 0;
+
 }
 
 static int lis2hh12_write_event_value(struct iio_dev *indio_dev,
-                                     const struct iio_chan_spec *chan,
-                                     enum iio_event_type type,
-                                     enum iio_event_direction dir,
-                                     enum iio_event_info info,
-                                     int val, int val2)
+		const struct iio_chan_spec *chan,
+		enum iio_event_type type,
+		enum iio_event_direction dir,
+		enum iio_event_info info,
+		int val, int val2)
 {
 	int err = 0;
-        struct lis2hh12_sensor_data *sdata = iio_priv(indio_dev);
+	struct lis2hh12_sensor_data *sdata = iio_priv(indio_dev);
 
 	switch(info) {
 		case IIO_EV_INFO_VALUE: 
 			/*
-        		* write inactivity threshold value
-        		*/
-        		err = lis2hh12_write_register(sdata->cdata, LIS2HH12_ACT_THS_ADDR,
-        		                        LIS2HH12_ACT_THS_MASK,
-        		                        val);
-        		if (err < 0)
-        		        return err;
-
-        		mdelay(40);
+			 * write inactivity threshold value
+			 */
+
+			if(wai ==  LIS2HH12_WHO_AM_I_DEF)  /*Condition for the HH12 acc chip*/
+			{
+				err = lis2hh12_write_register(sdata->cdata, LIS2HH12_ACT_THS_ADDR,
+						LIS2HH12_ACT_THS_MASK,
+						val);
+				if (err < 0)
+					return err;
+			}
+			else if(wai == LIS2DW12_WHO_AM_I_DEF) /*Condition for the DW12 acc chip*/
+			{
+				err = lis2hh12_write_register(sdata->cdata, LIS2DW12_WAKE_UP_THS_ADDR,
+						LIS2DW12_ACT_THS_MASK,
+						val);
+				if (err < 0)
+					return err;
+			}
+
+			mdelay(40);
 			break;
 
 		case IIO_EV_INFO_PERIOD:
 			/*
-        		* Write in activity interrupt duration
-        		*/
-        		err = lis2hh12_write_register(sdata->cdata, LIS2HH12_ACT_DUR_ADDR,
-        		                        LIS2HH12_ACT_DUR_MASK,
-        		                        val);
-        		if (err < 0)
-        		        return err;
-
-        		mdelay(40);
+			 * Write in activity interrupt duration
+			 */
+
+			if(wai == LIS2HH12_WHO_AM_I_DEF) /*Condition for the HH12 acc chip*/
+			{
+				err = lis2hh12_write_register(sdata->cdata, LIS2HH12_ACT_DUR_ADDR,
+						LIS2HH12_ACT_DUR_MASK,
+						val);
+				if (err < 0)
+					return err;
+			}
+			else if(wai == LIS2DW12_WHO_AM_I_DEF)      /*Condition for the DW12 acc chip*/
+			{
+				err = lis2hh12_write_register(sdata->cdata, LIS2DW12_WAKE_UP_DUR_ADDR,
+						LIS2DW12_ACT_DUR_MASK,
+						val);
+				if (err < 0)
+					return err;
+
+			}
+
+			mdelay(40);
 			break; 
 
 		default:
-		 printk("Default write case\r\n");
-		 break;
+			printk("Default write case\r\n");
+			break;
 	}
 
 }
@@ -927,11 +1238,11 @@ static const struct iio_info lis2hh12_info[LIS2HH12_SENSORS_NUMB] = {
 		.attrs = &lis2hh12_accel_attribute_group,
 		.read_raw = &lis2hh12_read_raw,
 		.write_raw = &lis2hh12_write_raw,
-	        .read_event_config = &lis2hh12_read_event_config,
-	        .write_event_config = &lis2hh12_write_event_config,
-	        .read_event_value = &lis2hh12_read_event_value,
-	        .write_event_value = &lis2hh12_write_event_value,
-	        .debugfs_reg_access = &lis2hh12_reg_access,
+		.read_event_config = &lis2hh12_read_event_config,
+		.write_event_config = &lis2hh12_write_event_config,
+		.read_event_value = &lis2hh12_read_event_value,
+		.write_event_value = &lis2hh12_write_event_value,
+		.debugfs_reg_access = &lis2hh12_reg_access,
 	},
 };
 
@@ -963,7 +1274,7 @@ static u32 lis2hh12_parse_dt(struct lis2hh12_data *cdata)
 		return -EINVAL;
 	/*TODO for this device interrupt pin is only one!!*/
 	if (!of_property_read_u32(np, "st,drdy-int-pin", &val) &&
-							(val <= 1) && (val > 0))
+			(val <= 1) && (val > 0))
 		cdata->drdy_int_pin = (u8) val;
 	else
 		cdata->drdy_int_pin = 1;
@@ -974,7 +1285,9 @@ static u32 lis2hh12_parse_dt(struct lis2hh12_data *cdata)
 
 int lis2hh12_common_probe(struct lis2hh12_data *cdata, int irq)
 {
-	u8 wai = 0;
+	/*comment out the wai local varibale and make it global
+	  u8 wai = 0;
+	  */
 	int32_t err, i, n;
 	struct iio_dev *piio_dev;
 	struct lis2hh12_sensor_data *sdata;
@@ -1015,7 +1328,7 @@ int lis2hh12_common_probe(struct lis2hh12_data *cdata, int irq)
 #endif /* CONFIG_OF */
 
 		dev_info(cdata->dev, "driver use DRDY int pin %d\n",
-						cdata->drdy_int_pin);
+				cdata->drdy_int_pin);
 	}
 
 	cdata->common_odr = 0;
@@ -1047,7 +1360,7 @@ int lis2hh12_common_probe(struct lis2hh12_data *cdata, int irq)
 		piio_dev->info = &lis2hh12_info[i];
 		piio_dev->modes = INDIO_DIRECT_MODE;
 		piio_dev->name = kasprintf(GFP_KERNEL, "%s_%s", cdata->name,
-								sdata->name);
+				sdata->name);
 	}
 
 	err =  lis2hh12_set_fifo_mode(sdata->cdata, BYPASS);
diff --git a/drivers/iio/accel/st_lis2hh12_trigger.c b/drivers/iio/accel/st_lis2hh12_trigger.c
index d85fbc4a924c..63f97f0378fb 100644
--- a/drivers/iio/accel/st_lis2hh12_trigger.c
+++ b/drivers/iio/accel/st_lis2hh12_trigger.c
@@ -18,6 +18,9 @@
 
 #include "st_lis2hh12.h"
 
+extern u8 wai;
+
+
 static irqreturn_t lis2hh12_irq_management(int irq, void *private)
 {
 	struct lis2hh12_data *cdata = private;
@@ -32,13 +35,28 @@ static irqreturn_t lis2hh12_irq_management(int irq, void *private)
 
 		if (status & LIS2HH12_FIFO_SRC_FTH_MASK)
 			lis2hh12_read_fifo(cdata, true);
-	} else {
+	} 
+	else 
+	{
 		cdata->tf->read(cdata, LIS2HH12_STATUS_ADDR, 1, &status);
+        
+		/*Change as per the data bit ready change for both the acc chip*/
+        if(wai == LIS2HH12_WHO_AM_I_DEF)    /*Condition for the HH12 acc chip*/
+		{
+			if (status & LIS2HH12_DATA_XYZ_RDY)
+			{
+				lis2hh12_read_xyz(cdata);
+			}
+		}
+		else if(wai == LIS2DW12_WHO_AM_I_DEF)    /*Condition for the DW12 acc chip*/
+		{
+			if (status & LIS2DW12_DATA_XYZ_RDY)
+			{
+				lis2hh12_read_xyz(cdata);
+			}
 
-		if (status & LIS2HH12_DATA_XYZ_RDY)
-			lis2hh12_read_xyz(cdata);
-	}
-
+		}
+	 }
 	return IRQ_HANDLED;
 }
 
-- 
2.17.1

